#!/usr/bin/python

import urllib2
from CharTropeSet import *
import sys,os
import random

folder = sys.argv[1]
if folder[-1] != "/":
	folder += "/"

chartropesets = []
ls = os.listdir(folder)
for filename in ls:
	chartropeset = CharTropeSet()
	f = open(folder+filename)
	chartropeset.load(f.read())
	f.close()
	if len(chartropeset.chars) != 0:
		chartropesets.append(chartropeset)

while True:
	sizecharset = random.choice(chartropesets)
	sizeset = random.choice(sizecharset.chars)
	generatesize = len(sizeset.tropes)
	if (generatesize > 3):
		break

tropes = {}
setchoices = []
charchoices = []
for i in range(generatesize):
	while True:
		setchoice = random.choice(range(len(chartropesets)))
		if setchoice in setchoices:
			continue

		charchoice = random.choice(range(len(chartropesets[setchoice].chars)))
		if len(setchoices) == 0:
			break

		sames = 0.0
		diffs = 0.0
		for s in range(len(setchoices)):
			already = chartropesets[setchoices[s]].chars[charchoices[s]]
			for altrope in already.tropes:
				for havetrope in chartropesets[setchoice].chars[charchoice].tropes:
					if altrope == havetrope:
						sames += 1.0
					else:
						diffs += 1.0

		coeff = sames / (sames+diffs)
		if coeff > 0.0 or (random.random() == 0.01 and random.random() == 0.01):
			break

	setchoices.append(setchoice)
	charchoices.append(charchoice)

	tropechoice = random.choice(range(len(chartropesets[setchoice].chars[charchoice].tropes)))
	itrope = chartropesets[setchoice].chars[charchoice].tropes[tropechoice]
	idesc = chartropesets[setchoice].chars[charchoice].descs[tropechoice]

	tropes[itrope] = idesc

keys = tropes.keys()
keys.sort()

print """
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
<link rel="stylesheet" type="text/css" href="http://static.tvtropes.org/css/css_white.css" />
<style>
strike{display:none;}
.strike{display:none;}
.YMMV_lit { background-position:-8px -7px; }
.YMMV { background-position:-8px -1190px; }
span.tiptag {font-size:smaller;cursor:pointer;}
span.notelabel {font-size:smaller;cursor:pointer;font-style:italic;}
.indent {margin-top:4px;margin-bottom:4px;}
</style>
</head>
<body>
<ul style="text-align:left;"><li>
"""

for trope in keys:
	print "<li><a  class='twikilink' href=\""+trope + "\">" + trope.split("/")[-1]+ "</a>" + tropes[trope]+"</li>"

print """
</ul>
</body>
</html>
"""
