#!/usr/bin/python

import urllib2
import re

class TropeSet:
	def __init__(self,html=""):
		self.tropes = []
		self.descs = []
		if html != "":
			self.load(html)
		return

	def load(self,html):
		begincursor = 0
		shortsearchstring = "<a class='twikilink' href='"
		searchstring = "<a class='twikilink' href='http://tvtropes.org/pmwiki/pmwiki.php/Main/"

		starts = [x.start() for x in re.finditer(searchstring,html)]
		ends = [x.start() for x in re.finditer("'",html)]
		descstarts = [x.start() for x in re.finditer("</a>:",html)]
		descends = [x.start() for x in re.finditer("</li>",html)]

		for start in starts:

			iend = start
			for iend in ends:
				if iend > start+len(shortsearchstring):
					end = iend
					break
			name = html[start+len(shortsearchstring):end]

			descstart = end
			for idescstart in descstarts:
				if idescstart > end:
					descstart = idescstart
					break
			descend = descstart
			for idescend in descends:
				if idescend > descstart:
					descend = idescend
					break

			desc = html[descstart:descend]
			desc = desc.replace("<li>","").replace("<ul >","")

			if "title='" in desc:
				desc = ""

			self.tropes.append(name)
			self.descs.append(desc)

if __name__ == "__main__":
	#response = urllib2.urlopen("http://tvtropes.org/pmwiki/randomitem.php?p=1")
	#response = urllib2.urlopen("http://tvtropes.org/pmwiki/pmwiki.php/Main/LiteratureOfThe2000s")
	response = urllib2.urlopen("http://tvtropes.org/pmwiki/pmwiki.php/Characters/Literature")
	html = response.read()
	tropes = TropeSet(html)
	for trope in tropes.tropes:
		print trope
